% The graph has to be an adjacency matrix with zeros and ones
% Loading the alarm graph
load net37_alarm_graph;

%%% Create Prior Knowledge %%%
% The PK was selected randomly, just to show how to run the algorithms
PK = {};

% 26 causes 4
PK{end+1} = createPK(26,4,1,1,0);
% 21 causes 12
PK{end+1} = createPK(21,12,1,1,0);
% 36 does not cause 14
PK{end+1} = createPK(36,14,0,1,0);
% 30 does not cause 19
PK{end+1} = createPK(30,19,0,1,0);

%%% Inferring PC-PDAG and PC-PAG, assuming consistent PK %%%
% Consistent PK, Inferring PC-PDAG
fprintf('Inferring PC-PDAG, consistent case\n');
PDAG = convertDagToPdag(graph, false);
PCPDAG = incorporatePK_PDAG(PDAG, PK);

% Consistent PK,  Inferring PC-PAG
fprintf('Inferring PC-PAG, consistent case\n');
L = []; % no latent vars
PAG = convertDagToPag(graph, L, false);
PCPAG = incorporatePK_PAG(PAG, PK);

%%% Inferring PC-PDAG and PC-PAG, assuming possibly inconsistent PK %%%

% The given PK is consistent
% Those are just examples to show how to run the algorithms

% Inconsistent PK, Inferring PC-PDAG
fprintf('Inferring PC-PDAG, possibly inconsistent case\n');
PDAG = convertDagToPdag(graph, false);
PK_ = incorporatePK_PDAG_BnB(PDAG, PK);
PCPDAG_ = incorporatePK_PDAG(PDAG, PK_);

% Inconsistent PK,  Inferring PC-PAG
fprintf('Inferring PC-PAG, possibly inconsistent case\n');
L = []; % no latent vars
PAG = convertDagToPag(graph, L, false);
PK_ = incorporatePK_PAG_BnB(PAG, PK);
PCPAG_ = incorporatePK_PAG(PAG, PK_);
