function [PK_out sat p] = incorporatePK_PAG_BnB(PAG, PK)

global nnodes;
global curscore;
global curpk;
global maxpag;

if(isempty(PK))
    PK_out = PK;
    sat = true;
    return;
end


nnodes = length(PAG.G);
curscore = -Inf;
curpk = [];

[sat] = search_all(PAG.G,PAG,PK);
PK_out = PK(curpk);
p = maxpag;
end

function [score Sat] = PKScore(bn, PK, closure)

[Sat Unsat Other] = SplitPK(bn,PK,closure);

assert(isempty(Other));

score = 0;
for i = 1:length(Sat)
    score = score + PK{Sat(i)}.w1;
end

for i = 1:length(Unsat)
    score = score + PK{Unsat(i)}.w2;
end

end

function [score] = MaxPKScore(bn, PK, closure)

[Sat Unsat Other] = SplitPK(bn,PK,closure);

score = 0;
for i = 1:length(Sat)
    score = score + PK{Sat(i)}.w1;
end

for i = 1:length(Unsat)
    score = score + PK{Unsat(i)}.w2;
end

for i = 1:length(Other)
    score = score + max(PK{Other(i)}.w1,PK{Other(i)}.w2);
end

end

function [sat] = search_all(pag, PAG, PK)
global curpk;
global curscore;
global maxpag;
[X,Y] = find(pag == 1,1);

if(isempty(X))
    closure = transitiveClosurePag_mex(pag);
    sat = ~hasCycle(closure) && ~hasAlmostCycle(pag,closure) && ~dncsViolated(pag, PAG.dnc) && ~independenciesViolated(PAG.sepSet, pag, closure);
    if(sat == true)
        [score satisfiedpk] = PKScore(pag,PK,closure);
        if(score > curscore)
            curscore = score;
            curpk = satisfiedpk;
            maxpag = pag;
        end
    end
    return;
end

% Test arrow
pag1 = pag;
pag1(X,Y) = 2;
pag1 = FCI_rules_apply(pag1, 0);
closure1 = transitiveClosurePag_mex(pag1);
sat1 = ~hasCycle(closure1) && ~hasAlmostCycle(pag1,closure1) && MaxPKScore(pag1,PK,closure1) > curscore && search_all(pag1,PAG,PK);

% Test tail
if(pag(Y,X) == 3)
    sat2 = false;
else
    pag2 = pag;
    pag2(X,Y) = 3;
    pag2(Y,X) = 2;
    pag2 = FCI_rules_apply(pag2, 0);
    closure2 = transitiveClosurePag_mex(pag2);
    sat2 = ~hasCycle(closure2) && ~hasAlmostCycle(pag2,closure2) && MaxPKScore(pag2,PK,closure2) > curscore && search_all(pag2,PAG,PK);
end

% Need to search both subtrees, can't stop here
sat = sat1 || sat2;

end
