function [PK_out sat] = incorporatePK_PDAG_BnB(PDAG, PK)

global nnodes;
global curscore;
global curpk;

if(isempty(PK))
    PK_out = PK;
    sat = true;
    return;
end

nnodes = length(PDAG.G);
curscore = -Inf;
curpk = [];


[sat] = search_all(PDAG.G,PK);
PK_out = PK(curpk);

end

function [score Sat] = PKScore(pdag, PK, closure)

[Sat Unsat Other] = SplitPK(pdag,PK,closure);

assert(isempty(Other));

score = 0;
for i = 1:length(Sat)
    score = score + PK{Sat(i)}.w1;
end

for i = 1:length(Unsat)
    score = score + PK{Unsat(i)}.w2;
end

end

function [score] = MaxPKScore(pdag, PK, closure)

[Sat Unsat Other] = SplitPK(pdag,PK,closure);

score = 0;
for i = 1:length(Sat)
    score = score + PK{Sat(i)}.w1;
end

for i = 1:length(Unsat)
    score = score + PK{Unsat(i)}.w2;
end

for i = 1:length(Other)
    score = score + max(PK{Other(i)}.w1,PK{Other(i)}.w2);
end

end


function [sat] = search_all(pdag, PK)
global curpk;
global curscore;

[X,Y] = find(pdag == 1,1);

if(isempty(X))
    closure = transitiveClosurePag_mex(pdag);
    sat = ~hasCycle(closure);
    if(sat == true)
        [score satisfiedpk] = PKScore(pdag,PK,closure);
        if(score > curscore)
            curscore = score;
            curpk = satisfiedpk;
        end
    end
    return;
end

% Test arrow
pdag1 = pdag;
pdag1(X,Y) = 2;
pdag1(Y,X) = 3;
pdag1 = PC_rules_apply(pdag1, 0);
closure1 = transitiveClosurePag_mex(pdag1);
sat1 = ~hasCycle(closure1) && MaxPKScore(pdag1,PK,closure1) > curscore && search_all(pdag1,PK);

% Test tail
pdag2 = pdag;
pdag2(X,Y) = 3;
pdag2(Y,X) = 2;
pdag2 = PC_rules_apply(pdag2, 0);
closure2 = transitiveClosurePag_mex(pdag2);
sat2 = ~hasCycle(closure2) && MaxPKScore(pdag2,PK,closure2) > curscore && search_all(pdag2,PK);

sat = sat1 || sat2;

end
