function [Sat Unsat Other] = SplitPK(pag,PK,closure)
% Splits the prior knowledge PK into 3 groups:
% Sat: those that are satisfied in pag
% Unsat: those that are not satisfied in pag
% Other: those that can be satisfied, but aren't yet

npk = length(PK);

PK_status = zeros(npk,1);

for i = 1:npk
    s = PK{i}.s;
    t = PK{i}.t;
    
    if(PK{i}.path)
        if(closure(s,t))
            PK_status(i) = 1;
        elseif(~hasPotentiallyDirectedPath(pag, s, t, closure))
            PK_status(i) = 2;
        else
            PK_status(i) = 3;
        end
    else
        if(~hasPotentiallyDirectedPath(pag, s, t, closure))
            PK_status(i) = 1;
        elseif(closure(s, t))
            PK_status(i) = 2;
        else
            PK_status(i) = 3;
        end
    end
end

Sat = find(PK_status == 1);
Unsat = find(PK_status == 2);
Other = find(PK_status == 3);

end
